from DiaLogger import Logger
import win32gui, win32con
from time import sleep
import os

log = Logger()
path = os.path.abspath(__file__)
BASE_DIR = os.path.dirname(os.path.dirname(path))


class Window:
    def __init__(self):
        # 设置进程句柄为空
        self._hwnd = 0
        # 当前文件路径
        self.path = os.getcwd()

    def CheckWindowHandle(self):
        if self._hwnd == 0:
            log.logger.warning("window handle not found  ! errCode : 10001")
            return None
        else:
            return 1

    def FindWindow(self, className, title):  # 获取窗口句柄
        sleep(0.1)
        hwnd = win32gui.FindWindow(className, title)
        if hwnd == 0:
            log.logger.warning("window handle not found ! errCode : 10001")
            return None
        else:
            log.logger.info("Gets the window handle...")
            self._hwnd = hwnd
            # 指定句柄设置为前台，也就是激活
            # win32gui.SetForegroundWindow(hwnd)
            # 设置为后台
            win32gui.SetBkMode(hwnd, win32con.TRANSPARENT)
            log.logger.info("Set to background mode...")

    def GetWindowPosition(self):  # 获取窗口位置
        #print(self.CheckWindowHandle())
        if self.CheckWindowHandle() == 1:
            return win32gui.GetWindowRect(self._hwnd)

    def SetWindowSize(self, w, h):
        if self.CheckWindowHandle() == 1:
            point = self.GetWindowPosition()
            if point != None:
                win32gui.MoveWindow(self._hwnd, point[0], point[1], w, h, False)
                log.logger.info('Changes window size...')

